<?php
/**
 * @package     CSVI
 * @subpackage  HikaShop
 *
 * @author      RolandD Cyber Produksi <contact@csvimproved.com>
 * @copyright   Copyright (C) 2006 - @year@ RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://csvimproved.com
 */

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('CsviForm');

/**
 * Select list form field for shipment.
 *
 * @package     CSVI
 * @subpackage  HikaShop
 * @since       7.10.0
 */
class CsvihikashopFormFieldOrdershipment extends JFormFieldCsviForm
{
	/**
	 * Type of field
	 *
	 * @var    string
	 * @since  7.10.0
	 */
	protected $type = 'OrderShipment';

	/**
	 * Get the options.
	 *
	 * @return  array  An array of shipping methods.
	 *
	 * @since   7.10.0
	 */
	protected function getOptions()
	{
		$query = $this->db->getQuery(true)
			->select(
				array(
					$this->db->quoteName('hikashop_shipping.shipping_id', 'value'),
					$this->db->quoteName('hikashop_shipping.shipping_name', 'text'))
			)
			->from($this->db->quoteName('#__hikashop_shipping', 'hikashop_shipping'))
			->rightJoin(
				$this->db->quoteName('#__hikashop_order', 'hikashop_order')
				. ' ON ' . $this->db->quoteName('hikashop_order.order_shipping_id') . ' = ' . $this->db->quoteName('hikashop_shipping.shipping_id')
			)
			->order($this->db->quoteName('text'))
			->group($this->db->quoteName('value'));

		$this->db->setQuery($query);
		$shipping = $this->db->loadObjectList();

		if (empty($shipping))
		{
			$shipping = array();
		}

		return array_merge(parent::getOptions(), $shipping);
	}
}
